% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y) = l_p(x)=log|x-p|
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B p(p=1.2,1.4,...,7.0) $B$HJQ2=!#(B gradient $B$N7W;;!#(B
% $B7KEDO@J8(B Fig 9-5 $B$N%0%i%U!#(B

format "long" "e"

rho=1;
R=2;

p=[1.2:0.2:7.0]';
mmax=length(p);

maxerror1=zeros(1,mmax);
maxerror2=zeros(1,mmax);

Ns=[4;50]; %N=4 $B$H(B N=50 $B$GHf3S$7$F79$-$r7W;;$9$k!#(B

for j=1:2    
  
  N=Ns(j);
  
  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B
  w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
  x=rho*w; % $B94B+E@(B
  y=R*w;   % $BEE2YE@(B

  Fs=zeros(N,mmax); % F: f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=log(abs(x-p(m)));    
    Fs(:,m)=f;
  end 

  G=zeros(N,N);
  for i=1:N
    G(i,:)=-log(abs(x(i)-y))'/(2*pi);
  end

  Qs=G\Fs; % Q: N $B9T(B mmax $BNs$N9TNs(B

  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax);
  for m=1:mmax 
    Q=Qs(:,m);
    for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); % csm $B$K$h$k6a;w(B
   
      u=log(abs(Z(l)-p(m))); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
    
    if j==1
      maxerror1(m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
    else
      maxerror2(m)=max(error(:,m));
    end
  end
end

tau=zeros(mmax,1);
for m=1:mmax
  g=(log10(maxerror2(m))-log10(maxerror1(m)))/(Ns(2)-Ns(1)); %$B79$-$N7W;;(B
  tau(m)=10^g;
end

pp=[0.0:0.05:7.0]';
mp=length(pp);

for k=1:mp
  taua(k)=sqrt(rho/pp(k));
  taub(k)=rho/R;
end

% $B%0%i%UI=<((B
grid "on"
gset title"Conventional Scheme Gradient"
gset xlabel"p"
gset ylabel"tau"

axis([0.0 7.0 0.0 1.1])

plot(p,tau,"@",pp,taua,";sqrt(rho/p);3",pp,taub,";rho/R;3")
gset term postscript eps color
gset output "fig9-5.eps"
replot
