% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y)=rho^m * cos(m theta) (cos=real)
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B
% $B8m:9$N%0%i%U!#(B

format "long" "e"

R=2;

m=1;   % m 
N=10;  % N ( $BJ,3d?t(B )  
n=100; % $BA*E@$N4V$NE@$N?t(B
  
omega=exp(2*pi*i/N);      % $B&X(B $B$NCM(B  
w=exp(2*pi*i*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
y=R*w;   % $BEE2YE@(B

rho=0:0.05:1.0;
randN=0:1/n:N;
rhod=length(rho);
randNd=length(randN);
[th,r] = meshgrid(2*pi*(randN)/N,rho);
[X,Y]  = pol2cart(th,r);

Z=X+i*Y;

for k=1:rhod  
  x=rho(k)*w; % $B94B+E@(B

  f=real(x.^m);    

  G=zeros(N,N);
  for i=1:N
    G(i,:)=-log(abs(x(i)-y))'/(2*pi);
  end

  Q=G\f; % Q; N $B9T(B mmax $BNs$N9TNs(B

  Us=zeros(rhod,randNd);
  for i=1:rhod
    for j=1:randNd
      U=(Q'*(-log(abs(Z(i,j)-y))))/(2*pi); % csm $B$K$h$k6a;w2r(B
      Us(i,j)=U;
    end
  end
end

%u=(r.^m).*(cos(m*th));
u=real(Z.^m); %$B87L)2r(B

UU=abs(Us-u);

% $B%0%i%UI=<((B (mesh $B$N%0%i%U(B)
grid "on"

gset xlabel"Real"
gset ylabel"Imaginary"
gset zlabel"error"

mesh(X,Y,UU)

gset term postscript eps color
gset output "gosamesh.eps"
replot
