% vX̊Ö
% {(x,y);x^2+y^2>r_0^2}
% u = 0 
% u(x,y)=f=(1/rho)*cos(theta)
% ʏXL[ɂB
% r_0 (r_0=1.0,1.2,...,3.0) ƕωB

format "long" "e"

R=0.8;

rho=[1.0:0.2:3.0]';
rhomax=length(rho);

Nmax=60; % N (  )̍ől
maxerror=zeros(rhomax,Nmax/2);

for N=2:2:Nmax
  for k=1:rhomax    
  
    omega=exp(2*pi*I/N);      %  ̒l 
    theta=(2*pi*(0:N-1)/N)'; 
    w=exp(theta*I); % xNg (^1 ^2 c ^N-1)' 
   
    x=rho(k)*w; % S_
    y=R*w;      % dד_
    f=(1/rho(k))*cos(theta); 

    G=zeros(N,N);
    for i=1:N
      G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi);
    end

    Q=G\f; % Q: N s mmax ̍s
  
    n=100; % E n ̓_
    Ztheta=2*pi*rand(n,1);
    Z=rho(k)*exp(I*Ztheta);
    error=zeros(n,Nmax/2); 
    for l=1:n
      U=Q'*((-(log(abs(Z(l)-y)./abs(Z(l)) )))/(2*pi)); % csm ɂߎ

      u=(1/rho(k))*cos(Ztheta(l));  % Ě̒l

      error(l,N/2)=abs(u-U); % EŌƋߎr
    end
  
    maxerror(k,N/2)=max(error(:,N/2)); % error ̍őlL  
  end
end
% Ot\
gset title"Conventional Scheme"
gset xlabel"r"
gset ylabel"log_10(e^(N))"

semilogy(rho,maxerror)
gset term postscript eps color
gset output "gaibucsmr.eps"
replot

