% $B%i%W%i%9J}Dx<0$N30ItNN0hLdBj(B
% {(x,y);x^2+y^2>rho^2}
% $B&$(Bu = 0 
% u(x,y) = l_p(x)=log|x-p|-log|x|
% $BITJQ%9%-!<%`$K$h$j2r$/!#(B
% $B6a;w2r$N%0%i%U!#(B

format "long" "e"

rho=2;
R=0.8;

p=0.4;  % m 
N=10; % N ( $BJ,3d?t(B )  
  
gp1=[0 ones(1,N)]; % Gtilde $B$N(B 1 $BNsL\$N@.J,(B
gp2=ones(N,1);     % Gtilde $B$N(B 1 $B9TL\$N@.J,(B 

omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B
theta=(2*pi*(0:N-1)/N)';  
w=exp(theta*I); % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
x=rho*w; % $B94B+E@(B
y=R*w;   % $BEE2YE@(B

f=log(abs(x-p))-log(abs(x));      
fo=[0 ; f];

G=zeros(N,N);
for i=1:N
  G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi); 
  % G; $B&#(B(x_i,y_j) $B$rMWAG$H$7$?(B N*N $B9TNs(B
end
Gtilde=[gp1;[gp2 G]]; % Gtilde $B$r:n$k!#(B

Qo=Gtilde\fo; % Q; N $B9T(B mmax $BNs$N9TNs(B

for s=1:N
 Qo2(s)=Qo(s+1);
end

rhod=rho:0.15:rho+4;
[th,r] = meshgrid(2*pi*(0:N)/N,rhod);
[X,Y]  = pol2cart(th,r);

Z=X+I*Y;
n=length(rhod);

Us=zeros(n,N+1);
for i=1:n
  for j=1:N+1
    U=Qo(1)+(Qo2'*(-log(abs(Z(i,j)-y))))/(2*pi); % $BITJQ%9%-!<%`$K$h$k6a;w2r(B
    Us(i,j)=U;
  end
end

%$B87L)2r(B
%u=log(abs(Z-p))-log(abs(Z));

% $B%0%i%UI=<((B (mesh $B$N%0%i%U(B)
grid "on"

gset xlabel"Real"
gset ylabel"Imaginary"
gset zlabel"U"

mesh(X,Y,Us)

gset term postscript eps color
gset output "gaibuinvmesh2.eps"
replot

