% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y) = l_p(x)=log|x-p|
% $BDL>o%9%-!<%`$K$h$j2r$/!#(Bp (p=1.2,1.4,...,2.6) $B$HJQ2=!#(B
% $B7KEDO@J8(B Fig 9-4 $B$N%0%i%U!#(B

format "long" "e"

rho=1;
R=2;

Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

p=[1.2:0.2:2.6]';
mmax=length(p);

maxerror=zeros(Nmax-1,mmax); %
ns=2:Nmax;

for N=2:Nmax;    
  
  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B
  w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
  x=rho*w; % $B94B+E@(B
  y=R*w;   % $BEE2YE@(B

  Fs=zeros(N,mmax); % F: f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=log(abs(x-p(m)));    
    Fs(:,m)=f;
  end 

  G=zeros(N,N);
  for i=1:N
    G(i,:)=-log(abs(x(i)-y))'/(2*pi);
  end

  Qs=G\Fs; % Q: N $B9T(B mmax $BNs$N9TNs(B
     
  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$jHf3S(B
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax);  
  for m=1:mmax
   Q=Qs(:,m); 
   for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); % csm $B$K$h$k6a;w(B
   
      u=log(abs(Z(l)-p(m))); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "fig9-4.eps"
replot




