% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y)=f=rho*cos(theta)
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B
% $B94B+E@$r(B kappa=1/2-10^(-m) $B$:$i$9!#(B m $B$NCM$r(B(m=2,4,...,14)$B$HJQ2=!#(B
% N $B$O6v?t$H$9$k!#(B
% $B7KEDO@J8(B Fig9-8 $B$N%0%i%U!#(B

format "long" "e"

rho=1;
R=2;

Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

m=[2:2:14]';
mmax=length(m);

maxerror=zeros(Nmax/2,mmax);
ns=2:2:Nmax;

for N=2:2:Nmax    
  
  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B  
  w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)' 

  y=R*w; %$BEE2YE@(B

  for j=1:mmax
    kappa=1/2-10^(-m(j));
    diff=exp(2*pi*I*kappa/N);  
    x=rho*w*diff; %$B94B+E@(B
  
    f=real(x.^1);  
 
    G=zeros(N,N);
    for i=1:N
      G(i,:)=-log(abs(x(i)-y))'/(2*pi);
    end

    Q=G\f; % Q; N $B9T(B mmax $BNs$N9TNs(B

    n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
    theta=2*pi*rand(n,1);
    Z=rho*exp(I*theta);
    error=zeros(n,mmax); 

    for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); % csm $B$K$h$k6a;w2r(B
   
      xx=Z(l).^1; 

      u=real(xx); % $B6-3&>e$NE@$NCM(B 
      
      error(l,j)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
  
    maxerror(N/2,j)=max(error(:,j)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "fig9-8.eps"
replot
