% vX̓̈
% {(x,y);x^2+y^2<r_0^2}
% u = 0 
% u(x,y)=f=rho*cos(theta)
% ʏXL[ɂB
% r_0 (r_0=0.2,0.4,...,1.8) ƕωB
% jc_ Fig9-9 ̃OtB

format "long" "e"

rho=[0.2:0.2:1.8]';
rhomax=length(rho);

R=2;

Nmax=60; % N (  )̍ől
maxerror=zeros(rhomax,Nmax/2);

for N=2:2:Nmax
  for k=1:rhomax    
  
    omega=exp(2*pi*I/N);      %  ̒l  
    w=exp(2*pi*I*(0:N-1)/N)'; % xNg (^1 ^2 c ^N-1)' 
   
    x=rho(k)*w; % S_
    y=R*w;      % dד_
    f=real(x.^1);  

    G=zeros(N,N);
    for i=1:N
      G(i,:)=-log(abs(x(i)-y))'/(2*pi);
    end

    Q=G\f; % Q: N s mmax ̍s
  
    n=100; % E n ̓_
    theta=2*pi*rand(n,1);
    Z=rho(k)*exp(I*theta);
    error=zeros(n,Nmax/2); 
    for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); % csm ɂߎ

      xx=Z(l).^1; 

      u=real(xx); % E̓_̒l 

      error(l,N/2)=abs(u-U); % EŌƋߎr
    end
  
    maxerror(k,N/2)=max(error(:,N/2)); % error ̍őlL  
  end
end
% Ot\
gset title"Conventional Scheme"
gset xlabel"r"
gset ylabel"log_10(e^(N))"

semilogy(rho,maxerror)
gset term postscript eps color
gset output "fig9-9.eps"
replot
