% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y) = l_p(x)=log|x-p|
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B
% $B87L)2r$H6a;w2r$N%0%i%U!#(B

format "long" "e"

rho=1;
R=2;

p=1.2; % p
N=10;  % N ( $BJ,3d?t(B )  
  
omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B  
w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
x=rho*w; % $B94B+E@(B
y=R*w;   % $BEE2YE@(B

f=log(abs(x-p));    

G=zeros(N,N);
for i=1:N
  G(i,:)=-log(abs(x(i)-y))'/(2*pi);
end

Q=G\f; % Q; N $B9T(B mmax $BNs$N9TNs(B

rhod=0:0.05:rho;
[th,r] = meshgrid(2*pi*(0:N)/N,rhod);
[X,Y]  = pol2cart(th,r);

Z=X+I*Y;
n=length(rhod);

Us=zeros(n,N+1);
for i=1:n
  for j=1:N+1
    U=(Q'*(-log(abs(Z(i,j)-y))))/(2*pi); % csm $B$K$h$k6a;w2r(B
    Us(i,j)=U;
  end
end


%$B87L)2r$r%0%i%U$K$9$k!#(B
[th2,r2] = meshgrid(2*pi*(0:100)/100,rhod);
[X2,Y2]  = pol2cart(th2,r2);
ZZ=X2+I*Y2;
u=log(abs(ZZ-p));

% $B%0%i%UI=<((B (mesh $B$N%0%i%U(B)
grid "on"

gset xlabel"Real"
gset ylabel"Imaginary"
gset zlabel"U"

mesh(X,Y,Us)
%mesh(X2,Y2,u)

gset term postscript eps color
gset output "csmmesh2.eps"
%gset output "genmitumesh2.eps"
replot



