% vX̓̈
% {(x,y);x^2+y^2<rho^2}
% u = 0 
% u(x,y) = l_p(x)=log|x-p|
% oɎqsσXL[ɂB 
% p(p=1.2,1.4,...,7.0) ƕωB gradient ̌vZB

format "long" "e"

rho=1;
R=2;

p=[1.2:0.2:7.0]';
mmax=length(p);

maxerror1=zeros(1,mmax);
maxerror2=zeros(1,mmax);

Ns=[4;50]; %N=4  N=50 ŔrČXvZB

fo=zeros(1,mmax);

for j=1:2    
  
  N=Ns(j);

  gp1=[0 ones(1,N)];
  gp2=ones(N,1); 

  omega=exp(2*pi*I/N);      %  ̒l  
  w=exp(2*pi*I*(0:N-1)/N)'; % xNg (^1 ^2 c ^N-1)'
  
  x=rho*w;    % S_
  y=R*w;      % dד_
  nu=(1/R)*y; % _y PʃxNg
  
  Fs=zeros(N,mmax); % F: f  mmax ׂčs
  for m=1:mmax 
    f=log(abs(x-p(m)));    
    Fs(:,m)=f;
    Fos=[fo ; Fs];
  end 
  
  G=zeros(N,N);
  for i=1:N
   G(:,i)=(-1/(2*pi))*(real(nu(i).*(((y(i)-x)').'))./(abs((y(i)-x))).^2); 
   % Dipole G
  end
  
  Gtilde=[gp1;[gp2 G]];

  Qos=Gtilde\Fos; % Q; N s mmax ̍s

  n=100; % E n ̓_
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax);

  Qo2=zeros(N-1,1); 
  
  for m=1:mmax 
    Qo=Qos(:,m);

    for s=1:N
      Qo2(s)=Qo(s+1);
    end
  
    for l=1:n
      U=Qo(1)+(Qo2'*((-1/(2*pi))*real(nu.*(((y-Z(l))').'))./(abs(y-Z(l))).^2)); 
      % Dipole ɂߎ
 
      u=log(abs(Z(l)-p(m))); % E̓_̒l
      
      error(l,m)=abs(u-U); % EŌƋߎr
    end
    
    if j==1
      maxerror1(m)=max(error(:,m)); % error ̍őlL
    else
      maxerror2(m)=max(error(:,m));
    end

  end
end

tau=zeros(mmax,1);
for m=1:mmax
  g=(log10(maxerror2(m))-log10(maxerror1(m)))/(Ns(2)-Ns(1)); %X̌vZ
  tau(m)=10^g;
end

pp=[0.0:0.05:7.0]';
mp=length(pp);

for k=1:mp
  taua(k)=sqrt(rho/pp(k));
  taub(k)=rho/R;
end

% Ot\
grid "on"
gset title"Invariant Dipole Scheme Gradient"
gset xlabel"p"
gset ylabel"tau"

axis([0.0 7.0 0.0 1.1]) % x y W̒l낦ĂB

plot(p,tau,"@",pp,taua,";sqrt(rho/p);3",pp,taub,";rho/R;3")
gset term postscript eps color
gset output "invdipolegradient.eps"
replot
