% vX̊Ö
% {(x,y);x^2+y^2>rho^2}
% u = 0 
% u(x,y)=(1/rho^m) * cos(m theta)
% ʏXL[ɂBƋߎ̌덷\B

format "long" "e"

rho=2;
R=0.8;

mmax=5;  % m ̍ől
Nmax=64; % N (  )̍ől

maxerror=zeros(Nmax-1,mmax);
ns=2:Nmax;

for N=2:Nmax; 
  
  omega=exp(2*pi*I/N);      %  ̒l
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I);           % xNg (^1 ^2 c ^N-1)' 
  
  x=rho*w; % S_
  y=R*w;   % dד_

  Fs=zeros(N,mmax); % F; f(El)  mmax ׂčs
  for m=1:mmax 
    f=(1/rho)^m*cos(m*theta);    
    Fs(:,m)=f;
  end 

  G=zeros(N,N); 
  for i=1:N
    G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi);
    % G; (x_i,y_j) vfƂ N*N s
  end

  Qs=G\Fs; % Q; N s mmax ̍s A

  n=100; % E n ̓_
  Ztheta=2*pi*rand(n,1);
  Z=rho*exp(I*Ztheta);
  error=zeros(n,mmax); 
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=Q'*((-(log(abs(Z(l)-y)./abs(Z(l)) )))/(2*pi)); % csm ɂߎ
   
      u=(1/rho)^m*cos(m*Ztheta(l)); % Ě̒l
      
      error(l,m)=abs(u-U); % Ƌߎr
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error ̍őlL
  end
end

% Ot\
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibuconv.eps"
replot








