% $B%i%W%i%9J}Dx<0$N30ItNN0hLdBj(B
% {(x,y);x^2+y^2>rho^2}
% $B&$(Bu = 0 
% u(x,y) = l_p(x)=log|x-p| - log|x|
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B p(p=0.2,0.4,...,1.8) $B$HJQ2=!#(B gradient $B$N7W;;!#(B

format "long" "e"

rho=2;
R=0.8;

p=[0.2:0.2:1.8]';
mmax=length(p);

maxerror1=zeros(1,mmax);
maxerror2=zeros(1,mmax);

Ns=[7;40]; %N=7 $B$H(B N=40 $B$GHf3S$7$F79$-$r7W;;$9$k!#(B

for j=1:2    
  
  N=Ns(j);

  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B  
  w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
  x=rho*w;    % $B94B+E@(B
  y=R*w;      % $BEE2YE@(B
  nu=(1/R)*y; % $B&M(B_y $BC10L%Y%/%H%k(B
  
  Fs=zeros(N,mmax); % F: f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=log(abs(x-p(m)))-log(abs(x));    
    Fs(:,m)=f;
  end 
  
  G=zeros(N,N);
  for i=1:N
   G(:,i)=(-1/(2*pi))*(real(nu(i).*(((y(i)-x)').'))./(abs((y(i)-x))).^2); 
   % Dipole G
  end
  
  Qs=G\Fs; % Q; N $B9T(B mmax $BNs$N9TNs(B
  
  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax);
  for m=1:mmax 
    Q=Qs(:,m);
    for l=1:n
      U=Q'*((-1/(2*pi))*real(nu.*(((y-Z(l))').'))./(abs(y-Z(l))).^2); 
      % Dipole $B$K$h$k6a;w2r(B
 
      u=log(abs(Z(l)-p(m)))-log(abs(Z(l))); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
    
    if j==1
      maxerror1(m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
    else
      maxerror2(m)=max(error(:,m));
    end

  end
end

tau=zeros(mmax,1);
for m=1:mmax
  g=(log10(maxerror2(m))-log10(maxerror1(m)))/(Ns(2)-Ns(1)); %$B79$-$N7W;;(B
  tau(m)=10^g;
end

pp=[0.0:0.05:1.8]';
mp=length(pp);

rho=2;
R=0.8;

for k=1:mp
  taua(k)=sqrt(pp(k)/rho);
  taub(k)=R/rho;
end

% $B%0%i%UI=<((B
grid "on"
gset title"Conventional Diple Scheme Gradient"
gset xlabel"p"
gset ylabel"tau"

axis([0.0 1.8 0.0 1.1])

plot(p,tau,"@",pp,taua,";sqrt(p/rho);3",pp,taub,";R/rho;3")

gset term postscript eps color
gset output "gaibucsmdipolegrad.eps"
replot



