% vX̊Ö
% {(x,y);x^2+y^2>rho^2}
% u = 0 
% u(x,y)=(1/rho)^m * cos(m theta)
% sσXL[ɂBƋߎ̌덷\B

format "long" "e"

rho=2;
R=0.8;

mmax=5;  % m ̍ől
Nmax=64; % N (  )̍ől

maxerror=zeros(Nmax-1,mmax);
ns=2:Nmax;
fo=zeros(1,mmax);

for N=2:Nmax;    
  
  gp1=[0 ones(1,N)];
  gp2=ones(N,1); 
  
  omega=exp(2*pi*I/N);      %  ̒l
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I); % xNg (^1 ^2 c ^N-1)' 
  
  x=rho*w; % S_
  y=R*w;   % dד_

  Fs=zeros(N,mmax); % F; f  mmax ׂčs
  for m=1:mmax 
    f=(1/rho)^m*cos(m*theta);    
    Fs(:,m)=f;
    Fos=[fo ; Fs];
  end 
  
  G=zeros(N,N);
  for i=1:N
    G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi); 
    % G; (x_i,y_j) vfƂ N*N s
  end
  Gtilde=[gp1;[gp2 G]];
 
  Qos=Gtilde\Fos; % Q; N s mmax ̍s A

  n=100; % E n ̓_
  Ztheta=2*pi*rand(n,1);
  Z=rho*exp(I*Ztheta);
  error=zeros(n,mmax); 
  
  Qo2=zeros(N-1,1); 
  
  for m=1:mmax
    Qo=Qos(:,m);
    
    for s=1:N
      Qo2(s)=Qo(s+1);
    end
    
    for l=1:n
      U=Qo(1)+(Qo2'*(-log(abs(Z(l)-y)./abs(Z(l)))))/(2*pi); 
      % sσXL[ɂߎ
   
      u=(1/rho)^m*cos(m*Ztheta(l));  % Ě̒l
      
      error(l,m)=abs(u-U); % Ƌߎr
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error ̍őlL
  end
end

% Ot\
gset title"Invariant Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibuinv.eps"
replot
