%Joukowski$BJQ49(B g(z)=(z+z^(-1))/2 $B$rMQ$$$F!"(B
%$BBJ1_NN0h$K$*$$$FBeMQEE2YK!$rE,MQ!#(B
%
%$BITJQ%9%-!<%`$K$*$1$k9M;!!#(B
%
%kappa = 0,rho=1.1,m=5(f=x^5) $B$r:NMQ!#(B
%R $B$NCM$rJQ2=$5$;$FI=<(!#(BR=1.2:0.4:4.0

format "long" "e"

rho=1.1;
R=[1.2:0.4:4.0]';
Rmax=length(R);

m=5;  % m $B$N:GBgCM(B
Nmax=100; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,Rmax);
ns=2:Nmax;

for k=1:Rmax
  for N=2:Nmax   
  
    gp1=[0 ones(1,N)];
    gp2=ones(N,1); 

    omega=exp(2*pi*I/N);
    w=exp(2*pi*I*(0:N-1)/N)';
    kappa=0;
    diff=exp(2*pi*I*kappa/N);

    gx=rho*w*diff;
    gy=R(k)*w;
  
    x=(gx+gx.^(-1))/2;
    y=(gy+gy.^(-1))/2;

    f=real(x).^m;  
    fo=[0 ; f];
    
    G=zeros(N,N);
    for i=1:N
      G(i,:)=-log(abs(x(i)-y))'/(2*pi);
    end
    Gtilde=[gp1;[gp2 G]];
  
    Qo=Gtilde\fo; % Q; N $B9T(B mmax $BNs$N9TNs(B
    
    n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
    theta=2*pi*rand(n,1);
    gZ=rho*exp(I*theta);
    Z=(gZ+gZ.^(-1))/2;
    error=zeros(n,1); 
    
    Qo2=zeros(N-1,1);

    for s=1:N
      Qo2(s)=Qo(s+1);
    end
 
    for l=1:n
      U=Qo(1)+(Qo2'*(-log(abs(Z(l)-y))))/(2*pi); %$BITJQ%9%-!<%`$K$h$k6a;w2r(B
     
      xx=real(Z(l));
   
      u=xx^m; % $B6-3&>e$NE@$NCM(B
      
      error(l)=abs(u-U);
    end
    
    maxerror(N-1,k)=max(error); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Elliptic Domain Invariant Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "elliptic4.eps"
replot








