% vX̊Ö
% {(x,y);x^2+y^2>rho^2}
% u = 0 
% u(x,y)=(1/rho^m) * cos(m theta)
% Joukowskiϊ g(z)=(z+z^(-1))/2 pāA
% ȉ~̈ɂđpdז@KpB
% ʏXL[ɂBƋߎ̌덷\B

format "long" "e"

rho=4;
R=2;

mmax=5;  % m ̍ől
Nmax=64; % N (  )̍ől

maxerror=zeros(Nmax-1,mmax);
ns=2:Nmax;

for N=2:Nmax; 
  
  omega=exp(2*pi*I/N);      %  ̒l
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I);           % xNg (^1 ^2 c ^N-1)' 
  kappa=0.5;
  difftheta=2*pi*kappa/N;
  diff=exp(difftheta*I);

  gx=rho*w*diff;
  gy=R*w;
  
  x=(gx+gx.^(-1))/2; % S_
  y=(gy+gy.^(-1))/2; % dד_ 

  Fs=zeros(N,mmax); % F; f(El)  mmax ׂčs
  for m=1:mmax 
    f=(1/rho)^m*cos(m*(difftheta+theta));    
    %f=real(x.^m); 
    Fs(:,m)=f;
  end 

  G=zeros(N,N); 
  for i=1:N
    G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi);
    % G; (x_i,y_j) vfƂ N*N s
  end

  Qs=G\Fs; % Q; N s mmax ̍s A
  %Qs=zeros(N,mmax);
  %w=zeros(N,1);
  %[q r] = qr(G);
  %for m=1:mmax  
  %  v=q'*Fs(:,m);
  %   
  %  w(N)=v(N)/r(N,N); 
  %  for k=N-1:-1:1
  %    w(k)=(v(k)-r(k,k+1:N)*w(k+1:N))/r(k,k);
  %  end
  %  Qs(:,m)=w;
  %end

  n=100; % E n ̓_
  Ztheta=2*pi*rand(n,1);
  gZ=rho*exp(I*Ztheta);
  Z=(gZ+gZ.^(-1))/2;
  error=zeros(n,mmax); 
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=Q'*((-(log(abs(Z(l)-y)./abs(Z(l)) )))/(2*pi)); % csm ɂߎ
   
      u=(1/rho)^m*cos(m*Ztheta(l)); % Ě̒l
            
      %xx=Z(l).^m;
   
      %u=real(xx); % E̓_̒l 

      error(l,m)=abs(u-U); % Ƌߎr
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error ̍őlL
  end
end

% Ot\
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibuelliptic.eps"
replot
